dofile("Base.rte/Constants.lua")
package.path = package.path .. ";Loyalists.rte/?.lua";
require("Actors/Vehicles/AI/NativeLoyalistVehicleAI")
require("Actors/Vehicles/AI/LoyalistVehicleSpecialBehaviours")

function Create(self)
	self.AI = NativeLoyalistVehicleAI:Create(self)

	self.tankMoraleTargetsTimer = Timer();
	self.tankMoraleTargetsDelay = 500
	self.tankMoraleTargets = {};
	self.tankMaxMoraleRange = 220 + self.Radius

end

function UpdateAI(self)

	if (not self:IsDead()) then
	
		LoyalistVehicleSpecialBehaviours.tankMorale(self)
		
	end

	self.AI:Update(self)
end

function Destroy(self)
	self.AI:Destroy(self)
end
