LoyalistVehicleSpecialBehaviours = {};

function LoyalistVehicleSpecialBehaviours.tankMorale(self)

	if self.tankMoraleTargetsTimer:IsPastSimMS(self.tankMoraleTargetsDelay) then
		self.tankMoraleTargetsTimer:Reset();
		for i = 1, #self.tankMoraleTargets do
			local testMoraleTarget = self.tankMoraleTargets[i];
			if testMoraleTarget and IsActor(testMoraleTarget) then
				testMoraleTarget:SetNumberValue("Tank Morale", 2)
			end
		end

		self.tankMoraleTargets = {};

		for act in MovableMan.Actors do
			if act.Team == self.Team and act.UniqueID ~= self.UniqueID and (act.PresetName == "Loyalist" or act.PresetName == "Fanatic" or act.PresetName == "Zealot" or act.PresetName == "Loyal Officer" or act.PresetName == "Loyal Commissar") then
				local trace = SceneMan:ShortestDistance(self.Pos, act.Pos, false);
				if (trace.Magnitude - act.Radius) < self.tankMaxMoraleRange then
					local strSumCheck = SceneMan:CastStrengthSumRay(self.Pos, self.Pos + trace, 3, rte.airID);
					if strSumCheck < 10 then
						table.insert(self.tankMoraleTargets, act);
					end
				end
			end
		end
	end			
end