function Create(self)

	self.RotAngle = 0

	for attachable in self.Attachables do
		if attachable.PresetName == "Loyalist Tank Engine" then
			self.engine = attachable;
		end
	end
end

function Update(self)
	
	if self.Health <= 0 then
		self:GibThis()
	end
	
	if not (self.engine and self.engine:IsAttached()) then
		self:SetLimbPathSpeed(1, 2)
	end

end

function Destroy(self)

	local tanker1 = CreateAHuman("Loyalist", "Loyalists.rte")
	local sidearm1 = RandomHDFirearm("Weapons - Secondary" , "Loyalists.rte");
	tanker1:AddInventoryItem(sidearm1)
	tanker1.Pos = self.Pos + Vector(-20*self.FlipFactor, -5):RadRotate(self.RotAngle)
	tanker1.Vel = self.Vel
	tanker1.RotAngle = self.RotAngle
	tanker1.HFlipped = self.HFlipped
	tanker1.AIMode = 1
	tanker1.Team = self.Team
	MovableMan:AddActor(tanker1)

	local tanker2 = CreateAHuman("Fanatic", "Loyalists.rte")
	local sidearm2 = RandomHDFirearm("Weapons - Secondary" , "Loyalists.rte");
	tanker2:AddInventoryItem(sidearm2)
	tanker2.Pos = self.Pos + Vector(0, -15):RadRotate(self.RotAngle)
	tanker2.Vel = self.Vel
	tanker2.RotAngle = self.RotAngle
	tanker2.HFlipped = self.HFlipped
	tanker2.AIMode = 1
	tanker2.Team = self.Team
	MovableMan:AddActor(tanker2)

	local tanker3 = CreateAHuman("Loyalist", "Loyalists.rte")
	local sidearm3 = RandomHDFirearm("Weapons - Secondary" , "Loyalists.rte");
	tanker3:AddInventoryItem(sidearm3)
	tanker3.Pos = self.Pos + Vector(20*self.FlipFactor, -5):RadRotate(self.RotAngle)
	tanker3.Vel = self.Vel
	tanker3.RotAngle = self.RotAngle
	tanker3.HFlipped = self.HFlipped
	tanker3.AIMode = 1
	tanker3.Team = self.Team
	MovableMan:AddActor(tanker3)

end