function Create(self)

	self.flareMoraleTargetsTimer = Timer();
	self.flareMoraleTargetsDelay = 300
	self.flareMoraleTargets = {};
	self.flareMaxMoraleRange = 400 + self.Radius
	
	self.deleteTimer = Timer();
	self.deleteDelay = math.random(65,85)*100

end

function Update(self)
	if self.flareMoraleTargetsTimer:IsPastSimMS(self.flareMoraleTargetsDelay) then
		self.flareMoraleTargetsTimer:Reset();
		for i = 1, #self.flareMoraleTargets do
			local flareMoraleTarget = self.flareMoraleTargets[i];
			if flareMoraleTarget and IsActor(flareMoraleTarget) then
				flareMoraleTarget:SetNumberValue("Flare Morale", 2)
			end
		end

		self.flareMoraleTargets = {};

		for act in MovableMan.Actors do
			if act.Team == self.Team and act.UniqueID ~= self.UniqueID and (act.PresetName == "Loyalist" or act.PresetName == "Fanatic" or act.PresetName == "Zealot" or act.PresetName == "Loyal Officer" or act.PresetName == "Loyal Commissar") then
				local trace = SceneMan:ShortestDistance(self.Pos, act.Pos, false);
				if (trace.Magnitude - act.Radius) < self.flareMaxMoraleRange then
					local strSumCheck = SceneMan:CastStrengthSumRay(self.Pos, self.Pos + trace, 3, rte.airID);
					if strSumCheck < 10 then
						table.insert(self.flareMoraleTargets, act);
					end
				end
			end
		end
	end
end