
function Create(self)

	----Relaod stuff
	
	self.reloadTimer = Timer();
	self.loadedShell = false;
	self.reloadCycle = false;
	self.stopReload = false;

	self.reloadDelay = 130;					--Time between each reload. Dosen'r teally matter to the player as smashing "R" completley undermines it
	
	self.reloadAngleSize = 0.3;

	self.parent = nil;

	self.origReloadTime = self.ReloadTime;
	self.firstShell = true;
	self.firstShellDelay = 800;			--How much is the reload time multiplied by for the first shell
	self.reloadNum = 0;

	if self.Magazine then
		self.magCount = self.Magazine.RoundCount;
		self.magTotal = self.Magazine.RoundCount;
	end
	
	self.emptyReload = false;

	---- Pupming stuff ----

	self.pullTimer = Timer();

	self.chamber = false;
	self.num = math.pi;
	self.casing = false;
	
	self.angleSize = 0.6;

	if self.Magazine then
		self.lastAmmo = self.Magazine.RoundCount;
	end
	
	self.pumpFront = self.SupportOfsset
	self.pumpBack = self.Pos + Vector(3*self.FlipFactor, -4)
		
	self.pump = 0
	self.pumpTimerHand = Timer();
	self.pumpDelay = 100
	
	self.pumpTimerFrame = Timer();
	
	self.hasReloadedTimer = Timer()
	self.hasReloaded = false;

end

function Update(self)

	-- shotgun reload starts here --
	if self.firstShell == true and self.reloadCycle == false then		--First shell in? between the movement and such it takes a bit more
		self.ReloadTime = self.firstShellDelay;		--Change if you want the first one to be way slwoer
	elseif self.firstShell == false then
		self.ReloadTime = self.origReloadTime;			--Change if you want the subsequent shells/bullets be slower/quicker
	end

	if self.parent then
		if self.reloadCycle == true then			--Yo we reloading, better grab my weapon better
			if self.reloadNum < 1 then
				self.reloadNum = self.reloadNum +1/self.Mass;
			elseif self.reloadNum > 1 then
				self.reloadNum = 1;
			end
		elseif	self.reloadCycle == false then		--Let's get back into it
			if self.reloadNum > 0 then
				self.reloadNum = self.reloadNum -1/self.Mass;
			elseif self.reloadNum < 0 then
				self.reloadNum = 0;
			end
		end
		self.RotAngle = self.RotAngle+self.FlipFactor*self.reloadNum*self.reloadAngleSize;		--The numbers above affect the rotation operation here
	else
		self.reloadNum = 0;
	end

	if self.Magazine ~= nil then
		if self.loadedShell == false then
			self.ammoCounter = self.Magazine.RoundCount;
		else
			self.loadedShell = false;
			self.Magazine.RoundCount = self.ammoCounter + 1;
			self.firstShell = false;
			
		end
	else
		self.reloadTimer:Reset();
		self.reloadCycle = true;
		self.loadedShell = true;
		if self.parent then
			self.parent:GetController():SetState(Controller.AIM_SHARP,false);
		end
	end

	if self.reloadCycle == true then
		if self:IsActivated() then
			self.stopReload = true;
		else
			self.stopReload = false;
		end
		
		if self.stopReload == true and self.parent:IsPlayerControlled() == true then
			local ctrl = self.parent:GetController();
			local screen = ActivityMan:GetActivity():ScreenOfPlayer(ctrl.Player); 
			PrimitiveMan:DrawTextPrimitive(screen, self.parent.AboveHUDPos + Vector(0, -3), "Stopping...", true, 0);	
		end
	else
		self.firstShell = true;
	end

	if self.reloadCycle == true and self.reloadTimer:IsPastSimMS(self.reloadDelay) and self:IsFull() == false then
		if self.parent then
			if self.stopReload == false then
				self:Reload();
			else
				self.reloadCycle = false
				self.stopReload = false;
			end
		end
	end

	if self.magCount == self.magTotal then	
		self.reloadCycle = false;
		self.stopReload = false;
		self.firstShell = true;
	end

		-- shotgun reload ends here --

	if self:IsAttached() == true then 		--I think this is more performance friendly as it doesn't check the parent every frame, rather just when the gun is first taken.
		if self.parent == nil then
			if IsAHuman(self:GetRootParent()) then
				self.parent = ToAHuman(self:GetRootParent())
			end
		end
	else
		self.parent = nil;
	end

	if self.parent then

		if self.Magazine then
			self.magCount = self.Magazine.RoundCount;
		end
	end

	if self.parent then
	
		if self.pumpTime == true then
			self.pumpTimerHand:Reset();
			self.pumpTime = false;
		end

		if self.pump == true then
			if self.pumpTimerHand:IsPastSimMS(self.pumpDelay) then
				self.SupportOffset = Vector(3, 3)
			end
		else
			self.SupportOffset = Vector(6, 3)
		end
		
		if self.magCount <= 0 and self:IsReloading() then
			self.emptyReload = true;
		end

		if self.magCount <= 0 and self.reloadCycle == true then		--We'll have to pump when finished reloading
			self.hasReloaded = true;
			self.hasReloadedTimerSet = true;
		end
			
		if self.Magazine then
			self.magCount = self.Magazine.RoundCount

			if self.FiredFrame and self.magCount > 0 then		--We fired and it's not the last round.

				self.chamber = true;
				self.pump = true
				self.pumpTime = true;
				self.pullTimer:Reset();
				self.num = math.pi;
				self.reloadFullSound = true;
		
				self.casing = true;
			end
			
			self.lastAmmo = self.Magazine.RoundCount;

			if self.Magazine.RoundCount == 0 and self:IsActivated() then
				self:Reload();
			end
			
			if self.FiredFrame then
				self.pumpTimerFrame:Reset();
			end
			
			------- Pump after empty reload -------------
				

			if self.reloadCycle == false then
			
				if self.hasReloadedTimerSet == true then
					self.hasReloadedTimer:Reset()
					self.hasReloadedTimerSet = false;
				end

				if self.hasReloaded == true then
					if self.hasReloadedTimer:IsPastSimMS(250) then
						self.chamber = true;
						self.pump = true
						self.pumpTime = true;
						self.pullTimer:Reset();
						self.num = math.pi;
						self.reloadFullSound = true;
						
						self.pumpTimerFrame:Reset();
			
						self.casing = true;
						
						self.hasReloaded = false
					end
				end
			end
			-----------------------------------------------
		end

		if self.chamber == true then	-- pulling the bolt
		
--			self:Deactivate()
		
			if self.pullTimer:IsPastSimMS(15000/self.RateOfFire) then

				if self.casing == true then
					casing = CreateMOSParticle("Shell");
					casing.Pos = self.Pos+Vector(-5*self.FlipFactor,-1):RadRotate(self.RotAngle);
					casing.Vel = self.Vel+Vector(-math.random(7,9)*self.FlipFactor,-math.random(5,7)):RadRotate(self.RotAngle);
					MovableMan:AddParticle(casing);

					self.casing = false;
				end
				
				if self.reloadFullSound == true then
					local soundEffect = CreateAEmitter("Loyalist Shotgun Pump Full","Loyalists.rte");
					soundEffect.Pos = self.Pos;
					MovableMan:AddParticle(soundEffect);
					self.reloadFullSound = false;
				end

				self.RotAngle = self.RotAngle +self.FlipFactor*math.sin(self.num)/2*self.angleSize;
				
				self.num = self.num - math.pi*0.0005*self.RateOfFire;
				
			end

			if self.num <= 0 then

				self.num = 0;
				self.chamber = false;
				self.pump = false;
				
			end
			
			------------- Horrible animation stuff, probably -----------------------
			
			if self.pumpTimerFrame:IsPastSimMS(46000/self.RateOfFire) then
				self.Frame = 0;
			
			elseif self.pumpTimerFrame:IsPastSimMS(45000/self.RateOfFire) then
				self.Frame = 1

			elseif self.pumpTimerFrame:IsPastSimMS(38500/self.RateOfFire) then
				self.Frame = 2
				self.pump = false;
				
			elseif self.pumpTimerFrame:IsPastSimMS(18000/self.RateOfFire) then
				self.Frame = 3
																
			elseif self.pumpTimerFrame:IsPastSimMS(14000/self.RateOfFire) then
				self.Frame = 2
				
			elseif self.pumpTimerFrame:IsPastSimMS(8500/self.RateOfFire) then
				self.Frame = 1	
			end	
			-----------------------------------------------------------------------
		end
	end
end