
function Create(self)

	if IsAHuman(self:GetRootParent()) then
		self.parent = ToAHuman(self:GetRootParent())
	else
		self.parent = nil;
	end
	
	self.genericChance = 0
	self.pouchesChance = 0
	self.spadeChance = 0
	self.maskChance = 0
	self.helmetChance = 0

	if self.parent then
		if self.parent.PresetName == "Loyalist" then
			self.pouchesChance = 0.4
			self.spadeChance = 0.5
			self.maskChance = 0.25
			self.helmetChance = 0.35
		elseif self.parent.PresetName == "Fanatic" then
			self.pouchesChance = 0		--NIU
			self.spadeChance = 0.35
			self.maskChance = 0.65
			self.helmetChance = 1		--NIU
		elseif self.parent.PresetName == "Zealot" then
			self.pouchesChance = 0		--NIU
			self.spadeChance = 0.25
			self.maskChance = 0
			self.helmetChance = 1		--NIU
		elseif self.parent.PresetName == "Loyal Officer" then
			self.pouchesChance = 1
			self.spadeChance = 0.4
			self.maskChance = 0		--NIU
			self.helmetChance = 0		--NIU
		end
	end
	
	if self.PresetName == "Loyalist Pouches" then
		self.chance = self.pouchesChance
	elseif self.PresetName == "Loyalist Spade" then
		self.chance = self.spadeChance
	elseif self.PresetName == "Loyalist Gas Mask" or self.PresetName == "Loyalist Heavy Gas Mask" then
		self.chance = self.maskChance
	elseif self.PresetName == "Loyalist Helmet A" then
		self.chance = self.helmetChance
	end

	if math.random() <= self.chance then
		self.Frame = 0
	else
		self.ToDelete = true
	end
	
end
