-------------------------------------------------------------------------------------------
--------------- Healing stuff from 4zK, I just added some stuff to it---------------------
-------------------------------------------------------------------------------------------

function Create(self)

	self.angleSize = -0.2;
	self.helpingOut = false;
	self.gonnaBandageYa = 0;

	self.parent = nil;
	self.target = nil;
end

function Update(self)

	--Animaiton stuff--
	if self:IsAttached() == true then 		--I think this is more performance friendly as it doesn't check the parent every frame, rather just when the gun is first taken.
		if self.parent == nil then
			if IsAHuman(self:GetRootParent()) then
				self.parent = ToAHuman(self:GetRootParent())
			end
		end
	else
		self.parent = nil;
	end

	if self.parent then
		if self.helpingOut == false then
			if self.gonnaBandageYa < 1 then
				self.gonnaBandageYa = self.gonnaBandageYa +1/14;
			elseif self.gonnaBandageYa > 1 then
				self.gonnaBandageYa = 1;
			end
		elseif	self.helpingOut == true then
			if self.gonnaBandageYa > -1 then
				self.gonnaBandageYa = self.gonnaBandageYa -1/14;
			elseif self.gonnaBandageYa < -1 then
				self.gonnaBandageYa= -1;
			end
		else
			self.reloadNum = 0;
		end

		if self.parent:GetController():IsState(Controller.AIM_SHARP) then
			self.helpingOut = true;
		else
			self.helpingOut = false;
		end
			
		self.RotAngle = self.RotAngle+self.FlipFactor*self.angleSize*self.gonnaBandageYa;
	end

	--Healing Stuff--

	if self:IsActivated() and self.Magazine ~= nil and self.Magazine.RoundCount ~= 0 then

		local curdist = 65
		for actor in MovableMan.Actors do
			vec = SceneMan:ShortestDistance(self.MuzzlePos,actor.Pos,SceneMan.SceneWrapsX);
			local dist = vec.Magnitude;
			if dist < curdist and actor.Team == self.Team then

				curdist = dist;
				self.target = ToActor(actor);
			end
		end

		if self.target == nil then
			self.target = ToActor(self.parent);
		end
	end

	if self.target then

		if not string.find(self.target.PresetName,"Robot") and not string.find(self.target.PresetName,"Drone") and not string.find(self.target.PresetName,"Turret") 
			and not string.find(self.target.PresetName,"Mech") and not string.find(self.target.PresetName,"Dummy") and not string.find(self.target.PresetName,"Dreadnought") 
			and not string.find(self.target.PresetName,"Whitebot") and not string.find(self.target.PresetName,"Patchbot") and not string.find(self.target.PresetName,"UA-") 
			and self.target.PresetName ~= "Silver Man" and self.target.PresetName ~= "Blast Runner" and self.target.ClassName ~= "ACDropShip" and self.target.ClassName ~= "ACRocket" 
			and self.target.ClassName ~= "ADoor" then

			if self.target.TotalWoundCount > 0 then

				local woundsRemoved = math.random(1,2)
				local bandagePos;
				local whereBandage = math.random() > 0.7 and "Head" or "Body"

				self.target:RemoveAnyRandomWounds(woundsRemoved);
				
				if whereBandage == "Head" and self.target.Head then
					bandagePos = Vector(math.random(-1,1), math.random(-3,3))
					self.target.Head:AddAttachable(CreateAttachable("Loyalist Bandages", "Loyalists.rte"), bandagePos)
				else
					bandagePos = Vector(math.random(-3,3), math.random(-5,5))
					self.target:AddAttachable(CreateAttachable("Loyalist Bandages", "Loyalists.rte"), bandagePos)
				end
				
				self.target:FlashWhite(50);
				AudioMan:PlaySound("Base.rte/Sounds/GUIs/SlicePicked.flac", self.Pos);

				-- Bandage used, time to discard it --

				self.ToDelete = true;
			else
				self.target = nil;
			end
		else
			self.target = nil;
		end
	end
end